/* PROGRAM TO ADD TWO LONG INTEGERS USING CIRCULAR LINK LIST */
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>

struct node{
		int info;
	    struct node *next;
	   };

void insert(struct node *,int);  /* Forward declaration */
struct node *addint(struct node *, struct node * );
void display(struct node *);

main()
{
	struct node *list1,*list2,*res;
   char lint[30],part[5];
   int i,j,no,m,n;
   clrscr();
   /* Initialising the two lists */
   list1=(struct node*) malloc(sizeof(struct node));
   list2=(struct node*) malloc(sizeof(struct node));
   list1->info=-1;
   list1->next=list1;
   list2->info=-1;
   list2->next=list2;
   printf("\nEnter two long integers:\n ");
   gets(lint);/* Entering first number */
   m=i=strlen(lint)-1;
   while(i>=0)
   {
   	for(j=3;j>=0;--j,--i)
        	if(i<0)
         	part[j]='0';
         else   
         	part[j]=lint[i];
      part[4]='\0';
      no=atoi(part);
      insert(list1,no);
   }
   gets(lint); /* Entering second number */
   n=i=strlen(lint)-1;
   while(i>=0)
   {
   	for(j=3;j>=0;--j,--i)
      	if(i<0)
         	part[j]='0';
         else
         	part[j]=lint[i];
      part[4]='\0';
      no=atoi(part);
      insert(list2,no);
   }
   res=addint(list1,list2);
   for(i=m;i<n-m;++i)
   	printf(" ");
   display(list1);
   for(i=n;i<m-n;++i)
      printf(" ");
   printf("\n+");
   display(list2);
   printf("\n");
   display(res);
   getch();
}

void insert(struct node *list,int no)
{
	struct node *temp,*head;
   head=list;
   temp=(struct node*)malloc(sizeof(struct node));
   temp->info=no;
   while(head->next->info !=-1)
   	head=head->next;
   head->next=temp;
   temp->next=list;
   return;
}

struct node *addint(struct node *p,struct node *q)
{
	int tenth=10000,carry,no,tot;
   struct node *s;
   p=p->next;
   q=q->next;
   s=(struct node*)malloc(sizeof(struct node));
   s->info=-1;
   s->next=s;
   carry=0;
   while(p->info!=-1 && q->info!=-1)
   {
   	tot=p->info+q->info+carry;
      no=tot%tenth;
      insert(s,no);
      p=p->next;
      q=q->next;
      carry=tot/tenth;
      //p=p->next;
   }
   while(p->info!=-1)
   {
   	tot=p->info+carry;
      no=tot%tenth;
      insert(s,no);
      carry=tot/tenth;
      p=p->next;
   }
   while(q->info!=-1)
   {
   	tot=q->info+carry;
      no=tot%tenth;
      insert(s,no);
      carry=tot/tenth;
      q=q->next;
   }
   if(carry==1)
   	insert(s,carry);
   return(s);
}

void display(struct node *p)
{
	struct node *q;
   char ch[5];
   int i,flag=0;
   while(p->next!=p)
   {
   	q=p;
      while(q->next->next !=p)
      	q=q->next;
      if(flag)
      {
      	itoa(q->next->info,ch,10);
         if((i=strlen(ch))!=4)
         	for( ;i<4;++i)
            	printf("0");
      }
      printf("%d",q->next->info);
      free(q->next);
      q->next=p;
      flag=1;
   }
}







