      /*PROGRAM DEMONSTRATING BASIC OPERATIONS OF A DOUBLELINK LIST*/

		    #include<stdio.h>
/**************/    #include<conio.h>
/*HEADER FILES*/    #include<stdlib.h>
/**************/    #include<alloc.h>
		    #include<time.h>

/*PREPOSSESSOR*/    #define NULL 0

     // GLOBAL DECLARATION  OF THE STRUCTURE OF DOUBLE LINKLIST//
	typedef struct list{
			     int info;
			     int node_num;
			     struct list *left;
			     struct list *right;
			   }dbllist;
	dbllist *move,*start,*travel;

		/*********************************/
		/*EXTERNAL FUNCTIONS DECLARATIONS*/
		/*********************************/
		void display();
		void add(int item);
		void insert(int item);
		int delete(int *p);
		void fun_free();
		void search_for(int node);
		void search_back(int node);

void main(void)
{
 int item,x,n;
 int p;
 char c='Y',desire,choice;
 char dir;
 clrscr();
 while(c!='N')            //i am using a header node
  {
   printf("\t************************************************************\n");
   printf("\t*PROGRAM TO DEMONSTRATE BASIC OPERARIONS ON DOUBLE LINKLIST*\n");
   printf("\t************************************************************\n");
   start=travel=NULL;
   travel=(dbllist*)malloc(sizeof(dbllist));
   start=move=travel;
   printf("ENTER ANY AMBIGUOUS VALUE (for header node):");
   scanf("%d",&travel->info);
   travel->node_num=0;
   travel->left=NULL;
   travel->right=(dbllist*)malloc(sizeof(dbllist));
   travel=travel->right;
   printf("PRESS \"C\" TO START A NEW LIST or ANY OTHER KEY TO QUIT:");
   while((desire=getche())=='C')
    {
     clrscr();
     printf("\n---------------------MAIN MENU-----------------------\n");
     printf("\nCHOOSE \"A\" FOR ADDITION\nCHOOSE \"D\" FOR DELETION\nCHOOSE \"V\" FOR DISPLAYING THE LIST\nCHOOSE \"I\" FOR INSERTION\nCHOOSE \"S\" FOR SEARCHING\n");
     printf("ENTER YOUR CHOICE:");
     choice=getche();
     switch(choice)
      {
	case 'A':
		  printf("\nENTER THE ITEM TO BE ADDED INTO THE LIST:");
		  scanf("%d",&item);
		  add(item);
		  break;

	case 'D':
		  printf("\nENTER THE NO. OF NODE TO BE DELETED:");
		  scanf("%d",&n);
		  travel=start;
		  do
		   {
		    if (travel->node_num==n) break;
		    else travel=travel->right;
		   }
		  while(travel->right!=NULL);
		  x=delete(&p);
		  printf("\nNODE NO.:%d ELEMENT DELETED FROM THE LIST:%d",p,x);
		  break;

	case 'V':
		 display();
		 break;

	case 'I':
		 printf("ENTER THE NO. OF NODE AFTER WHICH YOU WANT TO INSERT:");
		 scanf("%d",&n);
		 travel=start;
		  do
		   {
		    if (travel->node_num==n) break;
		    else travel=travel->right;
		   }
		  while(travel->right!=NULL);
		 printf("ENTER THE ITEM TO BE ADDED:");
		 scanf("%d",&item);
		 insert(item);
		 break;

	case 'S':
		 printf("ENTER THE NO. OF NODE WHICH YOU WANT TO FIND:");
		 scanf("%d",&n);
		 printf("Press \"F\" to search in forward direction or \"B\" to search in backward direction\n");
		 printf("ENTER YOUR CHOICE:");
		 dir=getche();
		 if(dir=='F') search_for(n);
		 else if(dir=='B') search_back(n);
		 else break;
		 break;
	default :
		 printf("\a\aREAD THE INSTRUCTIONS CLEARLY BEFORE PROCEEDING\n");
		 break;
      }
      printf("\nPRESS \"C\" TO CONTINUE EDITING THE SAME LIST or ANY OTHER KEY TO QUIT:");
    }
   fun_free();
   printf("\nDO YOU WISH TO START A NEW LIST ? (Press \"Y\" to proceed or \"N\" to quit):");
   c=getche();
  }
 printf("\nHOPE YOU ENJOYED THE SESSION.\tHAVE A GOOD DAY!");
 getch();
}


void add(int item)
{
 static int i=1;
 char c;
 travel->info=item;
 travel->node_num=i;
 i++;
 travel->left=move;
 move=travel;
 printf("DO YOU HAVE MORE ENTRIES ? (Press \"Y\" to confirm):");
 c=getche();
 if(c=='Y')
  {
   travel->right=(dbllist*)malloc(sizeof(dbllist));
   travel=travel->right;
  }
 else travel->right=NULL;
 printf("\a\nADDITION DONE SUCCESSFULLY");
}

int delete(int *p)
{
 int info;
 dbllist *temp;
 temp=travel;
 if (temp==NULL)
  {
   printf("\n\aLIST IS EMPTY!\nDELETION IMPOSSIBLE");
   exit(0);
  }
 else
  {
   info=temp->info;
   *p=temp->node_num;
   (temp->left)->right=temp->right;
   ((temp->left)->right)->node_num=((temp->left)->right)->node_num-1;
   (temp->right)->left=temp->left;
   temp->left=NULL;
   temp->right=NULL;
   printf("\a\nDELETION DONE SUCCESSFULLY");
   free(temp);
   return(info);
  }
}

void display()
{
 travel=start;
 printf("\nTHE LIST YOU HAVE MADE SO FAR IS AS FOLLOWS...");
 do
  {
   printf("\nNODE NO.:%d\tVALUE OF ELEMENT :%d",travel->node_num,travel->info);
   travel=travel->right;
  }
 while(travel->right!=NULL);
 printf("\nNODE NO.:%d\tVALUE OF ELEMENT :%d",travel->node_num,travel->info);
}

void insert(int item)
{
 int num;
 dbllist *temp,*r;
 temp=(dbllist*)malloc(sizeof(dbllist));
 num=travel->node_num;
 (travel->right)->node_num= (travel->right)->node_num+1;
 temp->info=item;
 temp->node_num=num+1;
 r=travel->right;
 r->left=temp;
 temp->right=r;
 temp->left=travel;
 travel->right=temp;
printf("\a\nINSERTION DONE SUCCESSFULLY");
}

void fun_free()
{
 dbllist *temp;
 travel=start;
 while(travel->right!=NULL)
  {
   temp=travel;
   travel=travel->right;
   free(temp);
  }
 free(travel);
 printf("\a\nALL NODES FREED");
}

void search_for(int node)
{
 travel=start;
 do
  {
   if (travel->node_num==node)
    {
     printf("\nINFORMATION STORED IN %d NODE IS :%d",node,travel->info);
     return;
    }
   else travel=travel->right;
  }
 while(travel->right!=NULL);
}

void search_back(int node)
{
 do
 {
   travel=travel->right;
 }
 while(travel->right!=NULL);
 do
  {
   if (travel->node_num==node)
    {
     printf("\nINFORMATION STORED IN %d NODE IS :%d",node,travel->info);
     return;
    }
  else travel=travel->left;
  }
 while(travel->left!=NULL);
}


























