/***************************CLASS EX-1***************************************/
/*************** PROGRAM FOR MAINTAINING A DIRECTORY ************************/
/****************************************************************************/

#include<iostream.h>
#include<iomanip.h>
#include<stdio.h>
#include<conio.h>
#include<string.h>
#include<stdlib.h>
#include<time.h>
#include<ctype.h>
#include<dos.h>
#define NULL 0

	      // GLOBAL DECL~N OF STRUCTURE
		  struct entry
		   {
		     char *name;
		     char *address;
		     int pincode;
		     long int phone_code;
		     int phone_no;
		     struct entry *next;
		    };
		   typedef struct entry individual;
		   individual *start,*travel;


void make_dir();    		// TO MAKE THE LIST FIRST
void add_entry();               // TO ADD ENTRIESY LATER
int delete_entry();             // TO DELETE ENTRIES LATER
void display_entry();           // TO DISPLAY THE ENTIRE LIST
void sort_name();               // TO SORT THE LIST ACCORD. TO NAMES
void modify_entry();            // TO EDIT THE LIST
void retrieve_entry();          // TO SEE AN ENTRY
void mem_free();
void main(void)
{
 time_t start,end;
 int i,j;
 char contd='y',choice;
 cout<<"PROGRAM TO CREATE A DIRECTORY\n";
 cout<<"DATA ENTRY BEGINS...\n";
 make_dir();
 while(contd=='y'||contd=='Y')
  {
    clrscr();
    cout<<"--------------------MAIN MENU --------------------------\n";
    cout<<"----------1. CHOOSE /'a/' OR /'A/' TO ADD ENTRIES-------\n";
    cout<<"----------2. CHOOSE /'d/' OR /'D/' TO DELETE ENTRIES----\n";
    cout<<"----------3. CHOOSE /'m/' OR /'M/' TO MODIFY ENTRIES----\n";
    cout<<"----------4. CHOOSE /'r/' OR /'R/' TO RETRIEVE AN ENTRY-\n";
    cout<<"----------5. CHOOSE /'v/' OR /'V/' TO VIEW ENTIRE LIST--\n";
    cout<<"--------------------------------------------------------\n";
    cout<<"PLEASE ENTER YOUR CHOICE : ";
    cin>>choice;
    choice=isupper(choice)?tolower(choice):choice;
    switch(choice)
     {
       case ('a'||'A'):
			add_entry();
			break;

       case 'd':
		  delete_entry();
		  break;
       case 'v':
		  display_entry();
		  break;
       case 'm':
		  modify_entry();
		  break;
       case 'r':
		  retrieve_entry();
		  break;
       default :
		  cout<<"\a\nYOU HAVE ENTERED A WRONG VALUE\n";
		  break;
     }
    cout<<"PRESS /'Y/' OR /'y/' TO CONTINE THE SAME LIST OR ANY OTHER KEY TO QUIT : ";
    getchar();
    fflush(stdin);
  }
 mem_free();    /* function to free the memory blocks */
 cout<<"THANKS FOR TRYING YOUR HAND AT IT\n";
 cin.get();
}


void  make_dir()
{
 time_t startlist,endlist;
 int i=1;
 time(&startlist);
 start=(individual*)malloc(sizeof(individual));
 cout<<i<<"."<<"RECORD";
 cout<<"\nENTER NAME : ";
 cin>>start->name;
 cout<<"ENTER ADDRESS : ";
 cin>>start->address;
 cout<<"ENTER PINCODE : ";
 cin>>start->pincode;
 cout<<"ENTER STD CODE OF TELEPHONE NO. : ";
 cin>>start->phone_code;
 cout<<"ENTER TELEPHONE NO. : ";
 cin>>start->phone_no;
 travel=start;
 do
  {
   i++;
   travel->next=(individual*)malloc(sizeof(individual));
   travel=travel->next;
   cout<<i<<"."<<"RECORD";
   cout<<"\nENTER NAME : ";
   cin>>travel->name;
   cout<<"ENTER ADDRESS : ";
   cin>>travel->address;
   cout<<"ENTER PINCODE : ";
   cin>>travel->pincode;
   cout<<"ENTER STD CODE OF TELEPHONE NO. : ";
   cin>>travel->phone_code;
   cout<<"ENTER TELEPHONE NO. : ";
   cin>>travel->phone_no;
  }
 while(strcmp(travel->name,"end")!=0);
 if(travel->name=="end") travel->next=NULL;
 cout<<"LIST IS COMPLETED SUCCESSFULLY\n";
 time(&endlist);
 cout<<"TIME TAKEN TO COMPLETE THE LIST IS : "<<setprecision(3)<<difftime(startlist,endlist);
 cout<<endl;
}

void mem_free()
{
 individual *temp;
 travel=start;
 do
  {
   temp=travel;
   travel=travel->next;
   free(temp);
  }
 while(travel->next!=0/*NULL*/);
 free(travel);
 cout<<"MEMORY ASSIGNED TO LIST IS COMPLETELY FREED\n";
}

void display()
{
 int i=1;
 travel=start;
 clrscr();
 cout<<"THE DIRECTORY AS FOLLOWS....\n";
 do
  {
   cout<<"n\n"<<i<<". RECORD\n\n";
   cout<<"NAME OF THE MEMBER         : "<<travel->name<<endl;
   cout<<"ADDRESS OF THE MEMBER      : "<<travel->address<<" "<<travel->pincode<<endl;
   cout<<"PHONE NUMBER OF THE MEMBER : "<<travel->phone_code<<"-"<<travel->phone_no<<endl;
   travel=travel->next;
   i++;
  }
 while(travel->next!=NULL);
 cout<<"----------------- END OF LIST ------------------\n";
}

void add_entry()
{
 char *name;
 individual *temp;
 travel=start;
 cout<<"\nPLEASE ENTER THE NAME OF THE PERSON : ";
 cin>>name;

 do
  {
   if (strcmpi(travel->name,name))


 while(travel->next!="end");
