/* PROGRAM TO IMPLEMENT DOUBLY LINK LIST */
# include <stdio.h>
# include <conio.h>
# include <ctype.h>
# define NULL 0
struct nodetype{
						 int info;
		   struct nodetype *left,*right;
					};
typedef struct nodetype node;
void create(node *start);
node *search(int x,node *st);
void insert(node *start);
void insloc(node *start,int i);
void insbef(node *ptr);
void insaft(node *ptr);
void delete(node *start);
void deleloc(node *start,int loca);
void delelem(node *ptr);
void display(node *start);
void dispfr(node *start);
void dispbk(node *start);
int f;
main()
{
 char c,ch;
 node *start,*ptr;
 int x;
/*---------------------MENU----------------------*/
ch='Y';
start=NULL;
do
{
  printf("Enter corresponding numbers for adjacent operations");
  printf("\n	1:Creation of the list.");
  printf("\n	2:Searching for a element.(Finding location.)");
  printf("\n	3:Addition of a new element ");
  printf("\n	4:Deletion of an element at a given position.");
  printf("\n	5:Displaying the linked list.");
  printf("\n	6:Exit.");
  printf("\nEnter your choice:");
  fflush(stdin);
  scanf("%c",&c);
  switch(c)
  {
  case '1':{clrscr();
	   printf("\n You have entered for creation.");
	   start=(node *) malloc(sizeof(node));
	   start->info=-100;
	   start->left=NULL;
	   start->right=NULL;
	    f=0;
	    create(start);
	    dispfr(start);
	    printf("\n The number of nodes is:%d",f);
	    break;}
  case '2':{clrscr();
	    printf("\n Input the element you want to search.");
	    scanf("%d",&x);
	    ptr = search(x,start);
	    break;}

  case '3':{clrscr();
	    printf("\n You have entered for insertion.");
	    insert(start);
	    break;
	    }
  case '4':{ clrscr();
	    printf("\n You have entered for deletion.");
	    delete(start);
	    break;
	    }
  case '5':{display(start);
	    break;}
   default:printf("\n Wrong entry.");
  }
printf("\n Do you want to continue?(y/n)/*MAIN MENU*/");
fflush(stdin);
scanf("%c",&ch);
}
while (toupper(ch)=='Y');
}
/*---------------------CREATE----------------*/
void create(node *start)
{ int x;
node *p,*q;
char cha;
p=start;
cha='Y';
do
{
 printf("\n Enter the element.");
 scanf("%d",&x);
 q=(node *) malloc(sizeof(node));
 q->info=x;

 p->right=q;
 q->left=p;
 q->right=start;
  start->left=q;
 p=q;
 f=f+1;
 printf("\n Do you want to continue? (Y/N)");
 fflush(std0in);
 scanf("%c",&cha);
 }
 while (toupper(cha)=='Y');
 return;
 }
/*---------------FUNCTION SEARCH-----------*/
node *search(int x,node *st)
{
node *temp,*ptr1;
int p=1,n;
temp=st->right;
/*while ( ((temp->info)!=-100)||((temp->info)!=x) )*/
while ((temp->info)!=x )

 {
 if ((temp->info) != -100)
 { p=p+1;
     temp=temp->right;
      }
      else
      { printf("\n Element not found.");
      ptr1=NULL;
      break;
      }
}
if ((temp->info)==x)
  {
	printf("\n Item found at position");
	printf("\n	** %d to the right of the header.",p);
   ptr1=temp;
   n=p;
   while((temp->info)!=-100)
   {temp=temp->right;
    n=n+1;

    }
      printf("\n	** %d to the left of the header.",(n-p));
  }
return(ptr1);

}

/*-------------FUNCTION INSERTION---------*/
void insert(node *start)
{
char chi='Y',ans;
int d,i;
node *ptr;
do
{
/*-------------------INSERTION SUB-MENU-------------------*/
printf("\n Enter corresponding numbers for adjacent operations.");
printf("\n	A:Inserting at desired position.");
printf("\n	B:Inserting before an element.");
printf("\n	C:Inserting after an element.");
printf("\n Enter choice:");
fflush(stdin);
scanf("%c",&ans);
switch(toupper(ans))
{
case 'A':{
	  printf("\nEnter the position at which you want to insert.");
	  scanf("%d",&i);
	  if (i>(f+1)) printf("\n Entry incompatible.");
	  else
	  {  insloc(start,i);
	   }
	   break;
	   }
case 'B':{
	 printf("\n Enter the element before which you wish to insert.");
	 scanf("%d",&d);
	 ptr=search(d,start);
	 if (ptr==NULL) break;
	 insbef(ptr);
	 break;
	 }
case 'C':{
	 printf("\nEnter the element after which you wish to insert.");
	 scanf("%d",&d);
	 ptr=search(d,start);
	 if (ptr==NULL) break;
	 insaft(ptr);
	 break;
	 }
default:printf("\n Wrong entry.");
}
printf("\n Do you want to continue ?(Y/N)/*INSERTION SUB-MENU*/");
fflush(stdin);
scanf("%c",&chi);
}
while(toupper(chi)=='Y');
return;
}

/*-------------FUNCTION TO INSERT AT LOCATION--------*/
void insloc(node *st1,int i1)
{
int ele,c;
node *q,*ptre;

ptre=st1->right;
c=1;
while(c!=i1)
{
ptre=ptre->right;
printf("	%d",ptre->info);
c=c+1;
}
printf("\n Enter the element you want to insert.");
fflush(stdin);
scanf("%d",&ele);
q=(node *) malloc(sizeof(node));
q->info=ele;
(ptre->left)->right=q;
q->left=ptre->left;
q->right=ptre;
ptre->left=q;
return;
}

/*-----------FUNCTION TO INSERT BEFORE AN ELEMENT ------*/
void insbef (node *ptr)
{ int ele;
node *q;
printf("\n Enter the element you want to insert");
scanf("%d",&ele);
q=(node *)malloc(sizeof(node));
q->info=ele;
(ptr->left)->right=q;
q->left=ptr->left;
q->right=ptr;
ptr->left=q;
return;
}


/*-----------FUNCTION TO INSERT AFTER AN ELEMENT ------*/
void insaft(node *ptr)
{ int ele;
 node *q;
 printf("\n Enter the element you want to insert");
 scanf("%d",&ele);
 q=(node *)malloc(sizeof(node));
 q->info=ele;
 (ptr->right)->left=q;
 q->right=ptr->right;
 q->left=ptr;
 ptr->right=q;
 return;
}






/*-------------FUNCTION DELETION----------*/
void delete(node *start)
{
node *ptrt;
char choi,chd;
int ele,loc;
chd='Y';
do
{
printf("\n Enter the corresponding number for adjacent operations.");
printf("\n 	X:Deleting element at a location.");
printf(":\n	Y:Deleting element given by user.");
printf("\nEnter choice:");
fflush(stdin);
scanf("%c",&choi);
switch(toupper(choi))
{
case 'X':         {
	  printf("\n Enter the location of the element you want to delete.");
	  fflush(stdin);
	  scanf("%d",&loc);
	  if (loc>f)
	  printf("\n Deletion incompatible.");
	  else { deleloc(start,loc);
	       printf("\n Element succesfully deleted.");

	    break;
		 }
	  }
case 'Y':{
	 printf("\n enter the element you want to delete.");
	 scanf("%d",&ele);
	 ptrt=search(ele,start);
	 delelem(ptrt);
	 break;
	 }
default:
	printf("\n Wrong entry.");
}
printf("\n Do you want to continue?(Y/N)---DELETION SUB-MENU---");
fflush(stdin);
scanf("%c",&chd);
}  while(toupper(chd)=='Y');
return;
}


/*-------------FUNCTION TO DELETE AT LOCATION--------*/
void deleloc(node *st1,int i1)
{
int c;
node *ptre;

ptre=st1->right;
c=1;
while(c!=i1)
{
ptre=ptre->right;
c=c+1;
}
(ptre->right)->left=ptre->left;
(ptre->left)->right=ptre->right;
ptre->left=NULL;
ptre->right=NULL;
free(ptre);
return;
}

/*-------------FUNCTION TO DELETE GIVEN ELEMENT--------------*/
void delelem(node *ptr7)
{
(ptr7->left)->right=ptr7->right;
(ptr7->right)->left=ptr7->left;
ptr7->left=NULL;
ptr7->right=NULL;
free(ptr7);
return;
}



 /*---------FUNCTION  DISPLAY--------*/

void display(node *start)
{
node *ptrt;
char choid,chdd;
chdd='Y';
do
{
printf("\n Enter the corresponding number for adjacent operations.");
printf("\n 	M:Displaying the doubly list forwards.");
printf(":\n	N:Displaying the list backwards.");
printf("\nEnter choice:");
fflush(stdin);
scanf("%c",&choid);
switch(toupper(choid))
{
case 'M':         {
	  printf("\n You have entered for forward display.");
	    dispfr(start);
	    break;
		 }

case 'N':{
	 printf("\n You have entered for backward display.");
	  dispbk(start);
	   break;
	 }
default:
	printf("\n Wrong entry.");
}
printf("\n Do you want to continue?(Y/N)---DISPLAYING SUB-MENU---");
fflush(stdin);
scanf("%c",&chdd);
}  while(toupper(chdd)=='Y');
return;
}




/*-------------FUNCTION FOR FORWARD DISPLAYING----*/
void dispfr(node *start)
{
node *temp;
clrscr();
printf("\n The list you have entered is as follows.\n");
temp=start->right;
while((temp->info)!=-100)
{
printf("	%d",temp->info);
temp=temp->right;
}
return;
}
/*-------------DISPLAY THE STRING BACKWARDS-----------*/
void dispbk(node *start)
{
node *temp;
clrscr();
printf("\n The list you have entered is as follows.\n");
temp=start->left;
while((temp->info)!=-100)
{
printf("	%d",temp->info);
temp=temp->left;
}
return;
}
