#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#define NORMAL 0
#define THICK  1
void drawline(int x1,int y1,int x2,int y2,int color,int width);
void mid_point_line(int x1,int y1,int x2,int y2,int color,int width);

int main(void)
{
   /* request auto detection */
   int gdriver =VGA, gmode=VGAHI, errorcode;
   initgraph(&gdriver, &gmode, "c:\\tc\\bgi");
   int midx;
   int maxx=getmaxx();
   int maxy=getmaxy();
   closegraph();
   restorecrtmode();
   int x11,x21,y11,y21,color,width;
   clrscr();
   printf("\n\nENTER THE CO-ORDINATES OF THE FIRST POINT,X(0-%d) AND Y(0-%d):",maxx,maxy);
   scanf("%d %d",&x11,&y11);
   printf("\n\nENTER THE CO-ORDINATES OF THE SECOND POINT,X(0-%d) AND Y(0-%d):",maxx,maxy);
   scanf("%d %d",&x21,&y21);
   printf("\n\nENTER THE COLOR(0-15):");
   scanf("%d",&color);
   printf("\n\nENTER THE WIDTH OF THE LINE (NORMAL-0 & THICK-1):");
   scanf("%d",&width);
   printf("\nPRESS ANY KEY TO CONTINUE.......");
   getch();
   clrscr();
   /* initialize graphics and local variables */
     initgraph(&gdriver, &gmode, "c:\\tc\\bgi");

   /* read result of initialization */
   errorcode = graphresult();
   if (errorcode != grOk)  /* an error occurred */
   {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:");
      getch();
      exit(1); /* terminate with an error code */
   }
   midx=getmaxx()/2;
   //midy=getmaxy()/2;
   setbkcolor(WHITE);
   moveto(midx,50);
   settextstyle(TRIPLEX_FONT,HORIZ_DIR,1);
   setcolor(RED);
   settextjustify(CENTER_TEXT,CENTER_TEXT);
   //clrscr();
   outtext("******************THIS PROGRAM***************** \n");
   moveto(midx,100);
   outtext(" DEMONSTRATES INCREMENTAL LINE DRAWING ALGORITHM\n");
   getch();
   setviewport(0,0,getmaxx(),getmaxy(),0);
   clearviewport();
   //clrscr();
   drawline(x11,y11,x21,y21,color,width);
   getch();
   setviewport(0,0,getmaxx(),getmaxy(),0);
   clearviewport();
   moveto(midx,50);
   outtext("*****************THIS PROGRAM***************** \n");
   moveto(midx,100);
   outtext(" DEMONSTRATES MID-POINT LINE DRAWING ALGORITHM\n");
   getch();
   setviewport(0,0,getmaxx(),getmaxy(),0);
   clearviewport();
   mid_point_line(x11,y11,x21,y21,color,width);
   getch();
   closegraph();
   restorecrtmode();
   return 0;
}
void drawline(int x1,int y1,int x2,int y2,int color,int width)
{
int x;
double y=y1;
double dy=y2-y1;
double dx=x2-x1;
double slope= dy/dx;
if(width==NORMAL)
     for(x=x1;x<=x2;x++)
       {putpixel(x,int(y) ,color);
       y+=slope;
       }
else
  {  for(x=x1;x<=x2;x++)
       {
       putpixel(x,int(y) ,color);
       putpixel(x,int(y)+1 ,color);
       putpixel(x,int(y)-1 ,color);
       y+=slope;
       }
  }
}
void mid_point_line(int x1,int y1,int x2,int y2,int color,int width)
{
int dx=x2-x1;
int dy=y2-y1;
int d=2*dy -dx;
int delE=2*dy;
int delNE=2*(dy-dx);
int x=x1;
int y=y1;
if( width==NORMAL)
 {      putpixel(x,y,color);
	   while(x<x2)
	   {
	   if(d<0){
		   d+=delE;
		   x++;
		   }
	   else{
		   d+=delNE;
		   x++;
		   y++;
	       }
	   putpixel(x,y,color);
	   }

}
else
{
  putpixel(x,y,color);
  putpixel(x,y+1,color);
  putpixel(x,y-1,color);
	   while(x<x2)
	   {
	   if(d<0){
		   d+=delE;
		   x++;
		   }
	   else{
		   d+=delNE;
		   x++;
		   y++;
	       }
	   putpixel(x,y,color);
	   putpixel(x,y+1,color);
	   putpixel(x,y-1,color);
	   }

}
}