		      ///***SCHAUM SERIES PROBLEM***///
		      ///***PROGRAM TO FIND x^n***///
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include  <math.h>
#define EPS1 .001
#define EPS2 100
int fact(int x);
float exp(float x);
float log_u(float x);
void main()
{
 int n;
 float x,sol,y;
 clrscr();
 printf ("ENTER x\t");
  if (x<=0)
   {
     printf ("\aPROGRAM VALID FOR ONLY POSITIVE VALUES OF x\n");
     exit(0);
   }
  scanf ("%f",&x);
  printf ("ENTER n\t");
  scanf ("%d",&n);
  y=log_u(x-1);
  //printf ("y=%f\n",y);
  sol=exp((n*y));
  printf ("x^n IS %5.2f\n",sol);
  printf ("THANKS FOR VISITING.HAVE A GOOD DAY!");
}

       float log_u (float x)
	       {
		 float sum=0,j=1,k;
		 int i=1;
		  if (x>=1)
		   {
		     k=log(x+1);
		     return(k);
		   }
		  else
		   {
		     while (fabs(j)>=EPS1)
		      {
		       j*=x;
		       k=j/i;
		       sum+=k;
		       i++;
		      }
		   }
		 return(sum);
		}

	 float exp (float a)
	  {
	   int i=1;
	   float sum=1,k,j=1;
	    if (a<1)
	     {
	       while (j>=EPS1)
		{
		  j=j*a;
		  k=j/fact(i);
		  sum+=k;
		  i++;
		}
	     }
	    else
	     {
	       while (j<=EPS2)
		{
		  j=j*a;
		  k=j/fact(i);
		  sum+=k;
		  i++;
		}
	     }
	   return(sum);
	  }

		int fact (int a)
		 {
		  if (a==1) return (1);
		  else return(a*fact(a-1));
		 }


