     /*PROGRAM TO CONVERT AN INFIX EXPRESSION TO PREFIX OPERATION*/

#include<stdio.h>
#include<conio.h>
#include<stdlib.h>
#include<alloc.h>
#include<string.h>
#include<time.h>
#define NULL 0
#define TRUE 1
#define	FALSE -1

		   typedef struct stack{
				char info;
				struct stack *last;
			       }stack;
		   stack *top/*,*travel*/;

/*1*/ int isempty();
/*2*/ char pop(stack **t);
/*3*/ void push(char symb);
/*4*/ void display(char str[],int n);
/*5*/ char stacktop();
/*6*/ int precedence(char x,char y);

void main(void)
{
 int i,j,p;
 char *str,*pre,symb;
 clrscr();
 printf("************************************************************\n");
 printf("*PROGRAM TO CONVERT AN INFIX EXPRESSION TO ITS PREFIX FORM*\n");
 printf("************************************************************\n");
   top=NULL;
   clrscr();
   printf("ENTER THE INFIX EXRESSION:");
   gets(str);
   i=strlen(str);
   pre=(char*)malloc(i*sizeof(char));
   p=0;
   for(j=i-1;j>=0;j--)
    {
     symb=*(str+j);
     if(symb!='^'&&symb!='/'&&symb!='*'&&symb!='+'&&symb!='-')
      {
       pre[p]=symb;
       p++;
      }
     else
      {
       while(isempty()==-1 && precedence(stacktop(),symb)==1)
	{
	 pre[p]=pop(&top);
	 p++;
	}
       push(symb);
      }
    }
   while(isempty()==FALSE)
    {
     pre[p]=pop(&top);
     p++;
    }
   j=p-1;
   printf("\nSTRING IN INFIX FORM IS \"%s\"",str);
   printf("\nSTRING IN PREFIX FORM IS ");
   for(i=j;i>=0;i--)
    {
     printf("%c",pre[i]);
    }
   free((char*)str);
   free((char*)pre);
 printf("\nHOPE YOU ENJOYED THE SESSION!\nHAVE A GOOD DAY!");
 getch();
}

int isempty()
{
 if (top==NULL) return(TRUE);
 else return(FALSE);
}

void push(char symb)
{
 stack *travel;
 travel=(stack*)malloc(sizeof(stack));
 travel->info=symb;//printf("%c",travel->info);
 travel->last=top;
 top=travel;
}

char pop(stack **t)
{
 char x;
 stack *temp;
 temp=*t;
 if(isempty(&temp)==TRUE)
  {
   printf("\n\aSTACK EMPTY!\n");
   temp=NULL;
   free(temp);
   exit(0);
  }
 else
  {
    temp=*t;
    x=temp->info;
    *t=temp->last;
    free(temp);
    return(x);
  }
}

char stacktop()
{
 if(isempty()==TRUE)
  {
   printf("\n\aSTACK EMPTY!");
   exit(0);
  }
 return(top->info);
}

int precedence(char c,char d)
{
 int i;
 if (c=='^'&&d=='^') return(FALSE);//(TRUE);
 if (c=='/'&&d=='/') return(FALSE);//(TRUE);
 if (c=='%'&&d=='%') return(FALSE);//(TRUE);
 if (c=='*'&&d=='*') return(FALSE);//(TRUE);
 if (c=='+'&&d=='+') return(FALSE);//(TRUE);
 if (c=='-'&&d=='-') return(FALSE);//(TRUE);
 if (c=='^'&&((d=='/')||(d=='%')||(d=='*')||(d=='+')||(d=='-'))) return(TRUE);
 if (c=='/'&&((d=='%')||(d=='*')||(d=='+')||(d=='-'))) return(TRUE);
 if (c=='%'&&((d=='/')||(d=='*')||(d=='+')||(d=='-'))) return(TRUE);
 if (c=='*'&&((d=='%')||(d=='/')||(d=='+')||(d=='-'))) return(TRUE);
 if (c=='+'&&d=='-') return (TRUE);
 if (c=='-'&&d=='+') return (TRUE);
 else
  {
    printf("\ni=0");
    return(FALSE);
  }
}
