//PROGRAM TO EVALUATE PREFIX EXPRESSION

#include<stdio.h>
#include<conio.h>
#include<stdlib.h>
#include<math.h>
#define MAXITEMS 80
#define TRUE 1
#define FALSE 0
// GLOBAL DECLARATION FOR STACK STRUCTURE

    struct stack{
		  int top;
		  int stk[MAXITEMS];
		};

// EXTERNAL FUNCTIONS USED IN PROGRAM
/*1.*/  int evaluate(char[]);
/*2.*/  int pop(struct stack *);
/*3.*/  void push(struct stack *,int);
/*4.*/  int isempty(struct stack*);
/*5.*/  int isdigit(char x);
/*5.*/  int oper(int,int,int);

void main(void)
{
  int count,l;
  char expr[MAXITEMS],*temp;
  clrscr();
  printf("ENTER THE STRING PREFIX STRING IN CONTINUOS FASHION\n");
  gets(temp);
  l=strlen(temp);
  for (count=l-1;count>=0;)
   {
    expr[l-(count+1)]=temp[count];
    count--;
   }
  expr[l]='\0';
  printf("ORIGINAL STRING IN PREFIX FORM IS:%s\n",temp);
  printf("VALUE OF THIS EXPRESSION IS %d\n",evaluate(expr));
  free((int*)temp);
  getche();
}

int isdigit(char symb)
{
  if (symb>='0'&&symb<='9') return(TRUE);
  else return(FALSE);
}

int pop(struct stack *p)
{
 int x;
 if (isempty(p))
  {
   printf("STACK UNDERFLOW");
   return(-1);
  }
 else
  {
   x=p->stk[p->top];
   p->top=p->top-1;
   return(x);
  }
}

void push(struct stack *p,int x)
{
 if (p->top==79)
  {
   printf("\aSTACK OVERFLOW\n");
   exit(1);
  }
 else
  {
   p->top++;
   p->stk[p->top]=x;
  }
}

int isempty(struct stack *p)
{
 if (p->top==-1) return(TRUE);
 else return(FALSE);
}

int oper(int symb,int oper1,int oper2)
{
 switch(symb)
 {
   case '+':  return(oper1+oper2);

   case '-':  return(oper1-oper2);

   case '*':  return(oper1*oper2);

   case '/':  if(oper2!=0) return(oper1/oper2);
	       else
		{
		  printf("INVALID ENTRY\n");
		  exit(1);
		}
   case '%':  if(oper2!=0) return(oper1%oper2);
	       else
		{
		  printf("INVALID ENTRY\n");
		  exit(1);
		}

   case '$':  return(pow(oper1,oper2));
   default :  printf("%s\n","ILLEGAL OPERATION");
	      exit(1);
 }
}

int evaluate(char exp[])
{
 char sym;
 int counter=0,oper1,oper2,value;
 struct stack opn_stack;
 opn_stack.top=-1;
 while ((sym=exp[counter])!='\0')
   {
     if(isdigit(sym)==1) push(&opn_stack,(int)(sym-'0'));
     else
      {
	oper2=pop(&opn_stack);
	oper1=pop(&opn_stack);
	value=oper(sym,oper1,oper2);
	push(&opn_stack,value);
      }
    counter++;
   }
  return(pop(&opn_stack));
}



