	/*PROGRAM NO.2 - CUSTOMER SUPPLIER RECORD*/

#include <stdio.h>
#include <time.h>
#include <dos.h>
#include <fstream.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <iomanip.h>
#include <ctype.h>


struct link
{
 int custumerID;
 char name[15];
 char add[40];
 char city[20];
 char state[20];
 long int zipcode;
 unsigned  long int phone;
 long int invoice_no;
 char date[20];
 long int amount;
 struct link  *next;
};

struct rec
{
 int custumerID;
 char name[15];
 char add[40];
 char city[20];
 char state[20];
 long int zipcode;
 unsigned  long int phone;

 long int invoice_no;
 char date[20];
 long int amount;
};

   inline int func1(link *temp)
   {
     if(temp==NULL)
      {
	 cout<<"\n\aSORRY!,CUSTOMER's LIST IS EMPTY\n";
	 getch();
	 return(0);
      }
     return(1);
   }



  class linked {
      private:
	      link *first;
      public:
	      linked(){
			first=NULL;
		      }
	     void get_rec();
	     void add_data();
	     void display();
	     void get_data(rec *temp);
	     void write_rec();
	     void find_rec();
	     void modify_rec();
	     void delete_rec();
};

void call_func(char *s)
{
      for (int i=0; i<strlen(s); i++)
      {
	 s[i] = toupper(s[i]);
      }
      return;
}

void linked::get_rec()
{
   int count;
   rec temp;
   ifstream fp;

   fp.open("c:\\custumer.dat", ios::app | ios::in);

   fp.read((char *)&temp, sizeof(temp));
   if(strcmp(temp.name, "               ")==0)
   {
      cout<<"\n\aALAS!,NO RECORDS TO SHOW\n";
      return;
   }
   while(!fp.eof())
   {
      get_data(&temp);
      fp.read((char*)&temp, sizeof(temp));
   }
   fp.close();
   display();
}

void linked::write_rec()
{
   link *temp=first;
   rec per;
   ofstream fp;

   fp.open("c:\\custumer.dat", ios::out);

   while(temp!=NULL)
   {  per.custumerID=temp->custumerID;
      strcpy(per.name, temp->name);
      strcpy(per.add, temp->add);
      strcpy(per.city,temp->city);
      strcpy(per.state,temp->state);
      per.zipcode=temp->zipcode;
      per.phone=temp->phone;

      per.invoice_no=temp->invoice_no;
      strcpy(per.date,temp->date);
      per.amount=temp->amount;

      fp.write((char*)&per, sizeof(per));
      temp=temp->next;
   }

   fp.close();
}

void linked::add_data()
{
   char ch;
   char *temporary;
   rec temp;
   int count=0;
   char temp0;
   clrscr();
   do{
      cout<<"\nENTER THE CUSTOMER's ID NO.: ";
      cin>>temporary;
      temp.custumerID=atoi(temporary);
      cout<<"\nENTER THE CUSTOMER's NAME : ";
      gets(temp.name);
      call_func(temp.name);
      cout<<"\nENTER THE CUSTOMER's ADDRESS :";
      gets(temp.add);
      cout<<"\nENTER THE CUSTOMER's TELEPHONE NO.:";
      cin>>temporary;
      temp.phone=atol(temporary);
      cout<<"\n ENTER THE CUSTOMER's CITY : ";
      gets(temp.city);
      cout<<"\n ENTER THE CUSTOMER's STATE : ";
      gets(temp.state);
      cout<<"\nENTER THE CUSTOMER's ARIAL ZIPCODE : ";
      cin>>temporary;
      temp.zipcode=atol(temporary);

      cout<<"\n ENTER THE CUSTOMER's INVOICE NO. :\n";
      cin>>temporary;
      temp.invoice_no=atoi(temporary);
      cout<<" \ENTER TODAY's DATE :\n";
      cin>>temp.date;
      cout<<" \ENTER THE CUSTOMER's AMMOUNT :\n";
      cin>>temporary;
      temp.amount=atol(temporary);
      get_data(&temp);
      cout<<"\n\aRECORD ADDED SUCCESSFULLY!";
      count++;
      cout<<"\nDO YOU WANT TO ENTER MORE RECORDS ? (Press \"y\" for yes or \"n\" for no) :";
      ch=getche();
      }while(ch== 'y' || ch=='Y');
   cout<<"\n"<<count<<"NEW RECORDS ADDED SUCCESSFULLY!\n";
}

void linked::get_data(rec *temp)
{
   static int count;
   link *store=new link;
   link *prev=first;
   link *last=NULL;
   store->custumerID=temp->custumerID;
   strcpy(store->name,temp->name);
   strcpy(store->add,temp->add);
   strcpy(store->city,temp->city);
   strcpy(store->state,temp->state);
   store->phone=temp->phone;
   store->zipcode=temp->zipcode;
   store->invoice_no=temp->invoice_no;
   strcpy(store->date,temp->date);
   store->amount=temp->amount;
   store->next=NULL;
   if(!count)
   {
      first=store;
      count++;
      return;
   }

   while(strcmpi(prev->name, store->name)<0)
   {
      last=prev;
      prev=prev->next;
      if(prev ==NULL)
	       break;
   }
   if(prev !=NULL)
   {
      if(last==NULL)
      {
	 store->next=first;
	 first=store;
      }
      else{
	 last->next=store;
	 store->next=prev;
      }
   }
   else{
	prev=last;            //prev now points to the the last node
	prev->next=store;
	store->next=NULL;
   }
}

void linked::display()  //member function to display
{
   link *temp=first;
   clrscr();
   if(func1(temp))
   {
   while(temp != NULL)
    {
    cout<<"CUSTOMER's ID NO.              : "<<temp->custumerID<<"\n";
    cout<<"CUSTOMER's NAME                : "<<temp->name<<"\n";
    cout<<"CUSTOMER's ADDRESS             : "<<temp->add<<"\n";
    cout<<"CUSTOMER's TELEPHONE NO. (off) : "<<temp->phone<<"\n";
    cout<<"CUSTOMER's CITY                : "<<temp->city<<"\n";
    cout<<"CUSTOMER's STATE               : "<<temp->state<<"\n";
    cout<<"CUSTOMER's ZIPCODE             : "<<temp->zipcode<<"\n";
    cout<<"CUSTOMER's INVOICE             : "<<temp->invoice_no<<"\n";
    cout<<"DATE OF LAST REFERENCE         : "<<temp->date<<"\n";
    cout<<"CUSTOMER's PRESENT AMOUNT      : "<<temp->amount<<"\n";
    temp=temp->next;
    cout<<"\nPRESS ANY KEY TO SEE NEXT RECORD...";
    getch();
    clrscr();
    cout<<"\n";
    }
   }
}

  void linked::delete_rec()
{
   link *temp=first;
   link *last=NULL;
   char str[15];

   clrscr();

   if(func1(temp))
   {
   display();
   cout<<"\n ENTER THE NAME OF THE PERSON WHOSE RECORD IS TO  BE DELETED : ";
   gets(str);
   call_func(str);

   while(temp!=NULL)
   {
      if(strcmp(temp->name, str)!=0)
      {
	 last=temp;
	 temp=temp->next;
      }
      else
	  break;
   }

   if(temp!=NULL)
   {
      if(last !=NULL)
	      last->next=temp->next;
      else
	  first=temp->next;
      delete temp;
      cout<<"\nRECORD DELETED";
   }
   else
   {
      cout<<"\n\aALAS!,RECORD TO BE DELETED NOT FOUND";
   }
   getch();
   }
}

void linked::find_rec()
{
   link *temp=first;
   char str[15];

   clrscr();

   if(func1(temp))
    {
     display();
     cout<<"\nENTER THE NAME OF THE PERSON WHOSE RECORD IS TO  BE FOUND : ";
     gets(str);
     call_func(str);

     while(temp!=NULL)
      {
	 if(strcmp(temp->name, str)!=0)
	 temp=temp->next;
	 else break;
      }

      if(temp!=NULL)
       {
	 cout<<"CUSTOMER's ID NO.              : "<<temp->custumerID<<"\n";
	 cout<<"CUSTOMER's NAME                : "<<temp->name<<"\n";
	 cout<<"CUSTOMER's ADDRESS             : "<<temp->add<<"\n";
	 cout<<"CUSTOMER's TELEPHONE NO. (off) : "<<temp->phone<<"\n";
	 cout<<"CUSTOMER's CITY                : "<<temp->city<<"\n";
	 cout<<"CUSTOMER's STATE               : "<<temp->state<<"\n";
	 cout<<"CUSTOMER's ZIPCODE             : "<<temp->zipcode<<"\n";
	 cout<<"CUSTOMER's INVOICE             : "<<temp->invoice_no<<"\n";
	 cout<<"DATE OF LAST REFERENCE         : "<<temp->date<<"\n";
	 cout<<"CUSTOMER's PRESENT AMOUNT      : "<<temp->amount<<"\n";
	 getch();
       }
    else  cout<<"\n\aSPECIFIED RECORD NOT FOUND";
   getch();
   }
}

void linked::modify_rec()
{
   link *temp=first;
   char str[15];
   char *temporary ;
   clrscr();

   if(func1(temp))
   {
   display();
   cout<<"\nENTER THE NAME OF THE CUSTOMER WHOSE RECORD IS TO BE MODIFIED : ";
   gets(str);
   call_func(str);

   while(temp!=NULL)
   {
      if(strcmp(temp->name, str)!=0)
	 temp=temp->next;
      else
	  break;
   }

   if(temp!=NULL)
   {
      cout<<"\nENTER THE CUSTOMER ID : ";
      cin>>temporary;
      temp->custumerID=atoi(temporary);
      cout<<"\nENTER THE CUSTOMER's NAME :";
      gets(temp->name);
      call_func(temp->name);cout << "\nENTER THE CUSTOMER's ADDRESS :";
      gets(temp->add);
      cout<<"\nENTER THE CUSTOMER's TELEPHONE NO. (off) :";
      cin>>temporary;
      temp->phone=atol(temporary);
      cout<<"\nENTER THE CUSTOMER's NATIVE CITY : ";
      gets(temp->city);
      cout<<"\nENTER THE CUSTOMER's STATE : ";
      gets(temp->state);
      cout<<"\nENTER THE CUSTOMER's ARIAL ZIPCODE NO.: ";
      cin>>temporary;
      temp->zipcode=atol(temporary);

      cout<<"\nENTER THE CUSTOMER's INVOICE NO. : ";
      cin>>temporary;
      temp->invoice_no=atoi(temporary);
      cout<<"\nENTER THE CURRENT DATE : ";
      cin>>temp->date;
      cout<<"\nENTER CURRENT BALANCE : ";
      cin>>temporary;
      temp->amount=atol(temporary);
      cout<<"\n\aRECORD MODIFIED SUCCESSFULLY ";
   }
   else
    {
      cout<<"\n\aSPECIFIED RECORD NOT FOUND";
    }
   getch();
   }
}

//---------------------------------------------------------------------------
//-------------------------------supplier data-------------------------------
//---------------------------------------------------------------------------

//STRUCTURE TO READ DATA FROM USER

struct link2
{
 int supplierID;
 char name2[15];
 char add2[40];
 char city2[20];
 char state2[20];
 long int zipcode2;
 unsigned  long int phone2;
 struct link2  *next2;
};

//STRUCTURE TO READ DATA FROM FILE

struct recsupplier
{
 int supplierID;
 char name2[15];
 char add2[40];
 char city2[20];
 char state2[20];
 long int zipcode2;
 unsigned long int phone2;
};


class supplier {
      private:
	      link2 *first2;
      public:
	      supplier()
	       {
		 first2=NULL;
	       }
	     void get_rec2();
	     void add_data2();
	     void display2();
	     void get_data2(recsupplier *temp2);
	     void write_rec2();
	     void find_rec2();
	     void modify_rec2();
	     void delete_rec2();
};

 int func2(link2 *temp2)
   {
   if(temp2==NULL)
   {
	 cout<<"\n\aALAS!,NO RECORD IN THE LIST\n";
	 getch();
	 return(0);
   }
   return(1);
  }

 void supplier::get_rec2()
{
   int count;
   recsupplier temp2;
  ifstream fp2;

   fp2.open("c:\\supplier.dat", ios::app | ios::in);
   fp2.read((char *)&temp2, sizeof(temp2));
   if(strcmp(temp2.name2, "               ")==0)
   {
      cout<<"\n\a\aALAS! NO RECORDS TO SHOW\n";
      return;
   }
   while(!fp2.eof())
   {
      get_data2(&temp2);
      fp2.read((char*)&temp2, sizeof(temp2));
   }
   fp2.close();
   display2();
}



void supplier::write_rec2()
{
   link2 *temp2=first2;
   recsupplier per2;
   fstream fp2;

   fp2.open("c:\\supplier.dat", ios::out);

   while(temp2!=NULL)
   {  per2.supplierID=temp2->supplierID;
      strcpy(per2.name2, temp2->name2);
      strcpy(per2.add2, temp2->add2);
      strcpy(per2.city2,temp2->city2);
      strcpy(per2.state2,temp2->state2);
      per2.zipcode2=temp2->zipcode2;
      per2.phone2=temp2->phone2;
      fp2.write((char*)&per2, sizeof(per2));
      temp2=temp2->next2;
   }

   fp2.close();
}

 void supplier::add_data2()
{
   char ch;
   char *temporary;
   recsupplier temp2;
   int count=0;
    clrscr();
   do{
      cout<<"\nPLEASE GIVE THE SUPPLIER's ID NO. : ";
      cin>>temporary;
      temp2.supplierID=atoi(temporary);
      cout<<"\nPLEASE GIVE THE SUPPLIER's NAME : ";
      gets(temp2.name2);
      call_func(temp2.name2);
      cout<<"\nPLEASE GIVE THE SUPPLIER's ADDRESS :";
      gets(temp2.add2);
      cout<<"\nPLEASE GIVE THE SUPPLIER's TELEPHONE NO. (off) :";
      cin>>temporary;
      temp2.phone2=atol(temporary);
      cout<<"\n PLEASE GIVE THE SUPPLIER's  CITY : ";
      gets(temp2.city2);
      cout<<"\n PLEASE GIVE THE SUPPLIER's STATE : ";
      gets(temp2.state2);
      cout<<"\nPLEASE GIVE THE SUPPLIER's ARIAL ZIPCODE NO. : ";
      cin>>temporary;
      temp2.zipcode2=atol(temporary);
      get_data2(&temp2);
      cout<<"\n\aRECORD ADDED SUCCESFULLY!\n";
      count++;
      cout<<"\nDO YOU WANT TO ADD MORE RECORDS ? Press \"y\" for yes or \"n\" for no) :";
      ch=getche();
      }while(ch== 'y' || ch=='Y');
   cout<<"\n"<<count<<"NEW RECORDS ADDED SUCCESSFULLY!\n";
   getch();
}

void supplier::get_data2(recsupplier *temp2)
{
   static int count;
   link2 *store2=new link2;
   link2 *prev2=first2;
   link2 *last2=NULL;


   store2->supplierID=temp2->supplierID;
   strcpy(store2->name2,temp2->name2);
   strcpy(store2->add2,temp2->add2);
   strcpy(store2->city2,temp2->city2);
   strcpy(store2->state2,temp2->state2);
   store2->phone2=temp2->phone2;
   store2->zipcode2=temp2->zipcode2;


   store2->next2=NULL;
   if(!count)
   {
      first2=store2;
      count++;
      return;
   }

   while(strcmpi(prev2->name2, store2->name2)<0)
   {
      last2=prev2;
      prev2=prev2->next2;
      if(prev2 ==NULL)
	       break;
   }
   if(prev2 !=NULL)
   {
      if(last2==NULL)
      {
	 store2->next2=first2;
	 first2=store2;
      }
      else{
	 last2->next2=store2;
	 store2->next2=prev2;
      }
   }
   else{
	prev2=last2;            //prev now points to the the last node
	prev2->next2=store2;
	store2->next2=NULL;
   }
}
 /// done upto here
void supplier::display2()
{
   link2 *temp2=first2;
   clrscr();
   if(func2(temp2))
   {
    while(temp2 != NULL)
   {
    cout<<"SUPPLIERS's ID NO.              : "<<temp2->supplierID<<"\n";
    cout<<"SUPPLIERS's NAME                : "<<temp2->name2<<"\n";
    cout<<"SUPPLIERS's ADDRESS             : "<<temp2->add2<<"\n";
    cout<<"SUPPLIERS's ZIPCODE NO.         : "<<temp2->zipcode2<<"\n";
    cout<<"SUPPLIERS's CITY                : "<<temp2->city2<<"\n";
    cout<<"SUPPLIERS's STATE               : "<<temp2->state2<<"\n";
    cout<<"SUPPLIERS's TELEPHONE NO. (off) : "<<temp2->phone2<<"\n";
    printf("\n\nPRESS ANY KEY TO SEE NEXT RECORD...");
    getch();
    clrscr();
    temp2=temp2->next2;
    cout<<"\n";
   }
   }
}

void supplier::delete_rec2()
{
   link2 *temp2=first2;
   link2 *last2=NULL;
   char str[15];

   clrscr();

   if(func2(temp2))
   {
   display2();
   cout<<"\nENTER THE NAME OF THE SUPPLIER WHOSE RECORD IS TO  BE DELETED : ";
   gets(str);
   call_func(str);

   while(temp2!=NULL)
   {
      if(strcmp(temp2->name2, str)!=0)
      {
	 last2=temp2;
	 temp2=temp2->next2;
      }
      else
	  break;
   }

   if(temp2!=NULL)
   {
      if(last2 !=NULL)
	      last2->next2=temp2->next2;
      else
	  first2=temp2->next2;
      delete temp2;
      cout<<"\n\aRECORD DELETED SUCCCESSFULLY";
      getch();
   }
   else
   {
      cout<<"\nSORRY! RECORD TO BE DELETED DOES NOT EXIST\n";
   }
   getch();
   }
}

void supplier::find_rec2()
{
   link2 *temp2=first2;
   char str[15];

   clrscr();

   if(func2(temp2))
   {
   display2();
   cout<<"\nENTER THE NAME OF THE PERSON WHOSE RECORD IS TO  BE FOUND : ";
   gets(str);
   call_func(str);

   while(temp2!=NULL)
   {
      if(strcmp(temp2->name2, str)!=0)
	 temp2=temp2->next2;
      else
	  break;
   }

   if(temp2!=NULL)
   {

    cout<<"SUPPLIER's ID. NO.     : "<<temp2->supplierID<<"\n";
    cout<<"SUPPLIER's NAME        : "<<temp2->name2<<"\n";
    cout<<"SUPPLIER's ADDRESS NO. : "<<temp2->add2<<"\n";
    cout<<"SUPPLIER's CITY        : "<<temp2->city2<<"\n";
    cout<<"SUPPLIER's STATE       : "<<temp2->state2<<"\n";
    cout<<"SUPPLIER's ZIPCODE     : "<<temp2->zipcode2<<"\n";
    cout<<"SUPPLIER's PHONE (off) : "<<temp2->phone2<<"\n";
   }
   else
   {
      cout<<"\nSORRY!,SPECIFIED RECORD NOT FOUND";
   }
   getch();
   }
}

void supplier::modify_rec2()
{
   link2 *temp2=first2;
   char str[15];
   char *temporary ;
   clrscr();

   if(func2(temp2))
   {
   display2();
   cout<<"\nENTER THE NAME OF THE PERSON WHOSE RECORD IS TO BE MODIFIED : ";
   gets(str);
   call_func(str);

   while(temp2!=NULL)
   {
      if(strcmp(temp2->name2, str)!=0)
	 temp2=temp2->next2;
      else
	  break;
   }

   if(temp2!=NULL)
   {
      cout<<"\nPLEASE GIVE THE SUPPLIER ID : ";
      cin>>temporary;
      temp2->supplierID=atoi(temporary);
      cout<<"\nPLEASE GIVE THE SUPPLIER's NAME :";
      gets(temp2->name2);
      call_func(temp2->name2);
      gets(temp2->add2);
      cout<<"\nPLEASE GIVE THE SUPPLIER's TELEPHONE NO.(off)  :";
      cin>>temporary;
      temp2->phone2=atol(temporary);
      cout<<"\nPLEASE GIVE THE SUPPLIER's NATIVE CITY : ";
      gets(temp2->city2);
      cout<<"\nPLEASE GIVE THE SUPPLIER's STATE : ";
       gets(temp2->state2);
       cout<<"\nPLEASE GIVE THE SUPPLIER's CITY'S ZIPCODE NO.: ";
       cin>>temporary;
       temp2->zipcode2=atol(temporary);

       cout<<"\a\nRECORD MODIFIED SUCCESSFULLY\n";
       getch();
   }
   else
   {
      cout<<"\n\aSORRY!,SPECIFIED RECORD NOT FOUND";
   }
   getch();
   }
}

void main()
{
   time_t t;
   struct tm *tb;
   linked li;
   supplier su;
   int option1,option2;
   char c='Y',d='Y';
   t=time(NULL);
   tb=localtime(&t);
   clrscr();
   cout<<"----------------------------------------------------------------------------\n";
   cout<<"------------------------PROGRAM NO. 2---------------------------------------\n";
   cout<<"----------------------------------------------------------------------------\n";
   cout<<"\n\nTODAY's DATE IS "<<asctime(tb);
   cout<<"PRESS A KEY TO CONTINE....\n";
   getch();
   clrscr();
   cout<<"\n\aPREVIOUS RECORDS OF CUSTOMERS ARE AS FOLOWS...\n";
   getch();
   clrscr();
   li.get_rec();
   clrscr();
   cout<<"\n\aPREVIOUS RECORDS OF SUPPLIERS ARE AS FOLOWS...\n";
   getch();
   su.get_rec2();
   while(c=='Y'||c=='y')
    {
      clrscr();
      cout<<"\n----------MAIN MENU FOR CUSTOMER DATA ENTRY-------";
      cout<<"\n\t\t 1. ADD NEW RECORDS";
      cout<<"\n\t\t 2. LIST ALL RECORDS";
      cout<<"\n\t\t 3. DELETE A RECORD";
      cout<<"\n\t\t 4. MODIFY AN EXISTING RECORD";
      cout<<"\n\t\t 5. FIND A RECORD";
      cout<<"\n\t\t 6. DISPLAY AND EXIT";
      cout<<"\n\t\tPLEASE ENTER YOUR CHOICE : ";

      cin>>option1;

      switch (option1)
      {
	 case 1:
		 li.add_data();
		 break;
	 case 2:
		 li.display();
		 getch();
		 break;
	 case 3:
		 li.delete_rec();
		 break;
	 case 4:
		 li.modify_rec();
		 break;
	 case 5:
		 li.find_rec();
		 break;
	 case 6:
		 clrscr();
		 li.display();
		 li.write_rec();
      }
     printf("\nPRESS \"Y\" or \"y\" TO GO BACK TO MAIN CUSTOMER's MENU : ");
     c=getche();
    }
    printf("\n\a SUPPLIER DATA ENTRY BEGINS...");
    while(d=='Y'||d=='y')
     {
      clrscr();
      cout<<"\n----------MAIN MENU FOR SUPPLIER DATA ENTRY-------";
      cout<<"\n\t\t 1. ADD NEW RECORDS";
      cout<<"\n\t\t 2. LIST ALL RECORDS";
      cout<<"\n\t\t 3. DELETE A RECORD";
      cout<<"\n\t\t 4. MODIFY AN EXISTING RECORD";
      cout<<"\n\t\t 5. FIND A RECORD";
      cout<<"\n\t\t 6. DISPLAY AND EXIT";
      cout<<"\n\t\tPLEASE ENTER YOUR CHOICE : ";

      cin>>option2;

      switch (option2)
       {
	case 1:
		su.add_data2();
		break;
	case 2:
		su.display2();
		getch();
		break;
	case 3:
		su.delete_rec2();
		break;
	case 4:
		su.modify_rec2();
		break;
	case 5:
		su.find_rec2();
		break;
	case 6:
		clrscr();
		su.display2();
		su.write_rec2();
       }
      printf("\nPRESS\"Y\" or \"y\" TO GO BACK TO MAIN SUPPLIER's MENU : ");
      d=getch();
     }
 cout<<"\nTHANKS FOR TRYING THE PROGRAM\nHAVE A GOOD DAY!\n";
 printf("\n\n---------------------------------------------------------\n");
 cout<<"\t\tPROGRAM CODED BY FOLLOWING STUDENTS\n";
 cout<<"-----\t\t1. NIKHIL BHARGAVA  141/COE/98\n";
 cout<<"-----\t\t2. JASMER SINGH     127/COE/98\n";
 cout<<"-----\t\t3. MANOJ KR. SAH    134/COE/98\n";
 printf("\n\n---------------------------------------------------------\n");
}

